import * as io from 'socket.io-client'

let host = process.env.TERA_HOST || 'http://127.0.0.1:8080/main'

let powClient = io(host, {
    path: '/ws'
})

powClient.on('connect', () => {
    // console.log(`Client ${powClient.id} connect ...`)
    powClient.emit('powclient', {})
    powClient.emit('web', `Connect to ${host} Successful...`)
    powClient.send({ cmd: "online", message: "OK" })
});

powClient.on('disconnect', (error) => {
    console.log(`Client disconnect Error: ${error}...`)
});

export { powClient }
